<template>
  <div id="changePassword" class="modal-container">
    <div class="modal-header">
      <p class="title">{{ $t('auth.change_password.title') }}</p>
      <button type="button" @click="closeModal()" class="btn-close"><span aria-hidden="true">×</span></button>
    </div>
    <div class="modal-body">
      <div class="form-group">
        <input
          @keyup.enter="changePassword"
          v-validate="'required'"
          @focus="resetError"
          data-vv-validate-on="none"
          v-model="currentPassword"
          type="password"
          :placeholder="$t('auth.change_password.current')"
          data-vv-as="current password"
          name="current_password"
          class="input">
        <span class="invalid-feedback" v-if="errors.has('current_password')">{{ errors.first('current_password') }}</span>
      </div>
      <div class="form-group">
        <input data-vv-as="new password"
           @keyup.enter="changePassword"
           v-validate="'required|min:6|max:128|regex:^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d).+$|no_space|confirmed:password_confirmation'"
           @focus="resetError"
           :placeholder="$t('auth.change_password.new')"
           v-tooltip="$t('auth.register.password_tooltip')"
           v-model="newPassword"
           data-vv-validate-on="none"
           name="password"
           type="password"
           class="input">
        <span class="invalid-feedback" v-if="isShowPasswordError">{{ errors.first('password') }}</span>
      </div>
      <div class="form-group">
        <input
          data-vv-as="password confirmation"
          @keyup.enter="changePassword"
          ref="password_confirmation"
          v-validate="'required'"
          @focus="resetError"
          data-vv-validate-on="none"
          :placeholder="$t('auth.change_password.repeat')"
          v-model="passwordConfirmation"
          name="password_confirmation"
          type="password"
          class="input">
        <span class="invalid-feedback" v-if="isShowPasswordConfirmedError">{{ errors.first('password') }}</span>
        <span class="invalid-feedback" v-if="errors.has('password_confirmation')">{{ errors.first('password_confirmation') }}</span>
      </div>

      <div class="text-center">
        <button type="button" class="btn btn-submit" @click="changePassword">{{ $t('auth.change_password.button') }}</button>
      </div>
    </div>
  </div>
</template>
<script>
import rf from '../../../../common/requests/RequestFactory';
import OtpConfirmModal from '../../../../common/components/Otp/OtpConfirmModal.vue';

export default {
  data() {
    return {
      currentPassword: null,
      newPassword: null,
      passwordConfirmation: null,
    }
  },
  computed: {
    isShowPasswordError () {
      return this.errors.has('password') && !this.errors.firstByRule('password', 'confirmed');
    },
    isShowPasswordConfirmedError () {
      return !!this.errors.firstByRule('password', 'confirmed') && !this.errors.firstByRule('password_confirmation', 'required');
    }
  },
  props: {
    modalData: {
      type: Object,
    }
  },
  methods: {
    closeModal() {
      this.$broadcast('close-modal');
    },
    resetError() {
      this.errors.clear();
    },
    changePassword() {
      this.$validator.validateAll()
      .then(() => {
        if (this.errors.any()) {
          return;
        }
        const params = Object.assign({}, {
          current_password: this.currentPassword,
          password: this.newPassword,
          password_confirmation: this.passwordConfirmation,
        });
        rf.getRequest('UserRequest')
          .changePassword(params)
          .then(() => {
            this.closeModal();
            this.changePasswordSuccessful();
          })
          .catch((error) => {
            const errors = error.errors;
            this.errors.clear();
            Object.keys(errors).forEach((key) => {
              this.errors.add({
                field: key,
                msg: errors[key][0]
              });
            });
            if (this.errors.has('code')) {
              this.$broadcast('open-modal', OtpConfirmModal, {
                callback: this.requestChangePassword,
                key: `requestChangePassword`,
                params: params,
              });
            }
          });
      });
    },
    requestChangePassword (params) {
      return rf.getRequest('UserRequest').changePassword(params);
    },
    changePasswordSuccessful () {
      this.$toasted.show(this.$t('messages.auth.changePassword.changePasswordSuccessful'), {
        theme: 'bubble',
        position: 'top-right',
        duration : 1000
      });

      setTimeout(() => {
        window.location.href = '/login';
      }, 1000);
    },
  },
};
</script>
<style scoped lang="scss">
  @import '../../../../../sass/_variables.scss';
  * {
    font-family: $font-family-home;
  }
  #changePassword {
    width: 450px;
    height: 395px;
    border-radius: 10px;
    background-color: #f7f7f7;
    box-shadow: 0 2px 40px 0 rgba(0, 0, 0, 0.18);
    margin: auto;
    .modal-header {
      padding: 0;
      border: none;
      position: relative;
      .title {
        font-size: 18px;
        font-weight: bold;
        color: #1c1c1c;
        text-align: center;
        margin: 55px auto 5px;
      }
      .btn-close {
        width: 30px;
        height: 30px;
        background-color: $bg_white;
        border: 1px solid $white;
        border-radius: 50%;
        position: absolute;
        outline: none;
        top: 15px;
        right: 15px;
        span {
          cursor: pointer;
          color: $thin_gray;
          font-size: 17px;
        }
      }
    }
    .modal-body {
      margin: 0;
      padding: 0;
      .form-group {
        text-align: center;
        background: none;
        margin: 20px auto 0;
        position: relative;
        padding: 0;
        width: 330px;
        input {
          width: 100%;
          height: 40px;
          border-radius: 74px;
          background-color: $bg_white;
          border: 1px solid $white;
          font-size: 14px;
          padding: 0 15px;
          outline: none;
          &:placeholder {
            color: #cacaca;
          }
        }
      }
      .btn-submit {
        margin-top: 30px;
        width: 170px;
        height: 32px;
        border-radius: 30px;
        border: solid 1px $orange;
        font-size: 14px;
        font-weight: bold;
        font-style: normal;
        font-stretch: normal;
        line-height: normal;
        letter-spacing: 0.5px;
        color: white;
        outline: none;
        background: $orange;
        &:focus {
          box-shadow: none!important;
        }
        &:hover {
          background: $dark_orange;
          color: white;
        }
      }
    }
    .invalid-feedback {
      color: red;
      position: absolute;
      text-align: left;
      bottom: -20px;
      font-size: 13px;
      left: 15px;
    }
  }
</style>
